/*************************************************************************
 *
 * PROGRAM	3d-dreher
 * PART
 * VERSION
 * DATE
 * CHANGED
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * EMAIL	Internet: k.rotter@ame.nbg.sub.org
 *		Z-Netz:   k.rotter@ame.zer
 * COMPUTER	Amiga with OS 2.04
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	DICE 2.06
 * COPYRIGHT	(c) Copyright 1992 by Klaus Rotter
 * COMMENT
 *
 * HISTORY
 *
 *************************************************************************/

#include <math.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/exec_protos.h>

#include <graphics/gfx.h>

#define PI 3.141593
#define trunc(x) ((int) x)

struct Window *Win1, *Win2;
struct Screen *Scr;
struct RastPort *Rp, *RpWB;
struct IntuiMessage *Msg;

struct IntuitionBase *IntuitionBase;
struct GfxBase *GfxBase;

short  s,sx,i,q,sl,p,lo;
float  l,m,n;
float  w;
float  xf,yf,zf,Az;
float  v,r;
float  x,y,z;
float  a,o,t,u;
char   asc;
float  xk[100],yk[100],zk[100];

float Data[] = {
      50, 50,  0, 200 ,50,  0, 200, 50,  0, 200, 50,100,
     200, 50,100,  50 ,50,100,	50, 50,100,  50, 50,  0,
      50, 50,  0, 125,150, 50, 200, 50,  0, 125,150, 50,
     200, 50,100, 125,150, 50,	50, 50,100, 125,150, 50,
       0,-10,  0,   0,-10,200, 200,-10,  0, 200,-10,200,
       0,-10,  0, 200,-10,200,	 0,-10,200, 200,-10,  0,
      -1, -1, -1
};

void Drehen(void)
{
    float e,c,b,

    e = fsqrt((a-t)*(a-t)+(o-u)*(o-u));
    c = fabs(fatan((u-o)/(t-a)));
    if ((t-a) > 0) c = -c-PI;
    b = w+c;
    if ((u-o) > 0) {
	c = -c;
	b = w+c;
    }
    a = t+fcos(b)*e;
    o = u+fsin(b)*e;
}

void Richtung(void)
{
    x = xk[q]; y = yk[q]; z = zk[q];
    p = q; q = q+1;
    if (asc == 'z') {
	a = x; o = y;
	t = l; u = m;
	Drehen();
	x = a; y = o;
    }
    else if (asc == 'y') {
      a = x; o = z;
      t = l; u = n;
      Drehen();
      x = a; z = o;
    }
    else if (asc == 'x') {
      a = y; o = z;
      t = m; u = n;
      Drehen();
      y = a; z = o;
    }

    xk[p] = x;
    yk[p] = y;
    x = xf-(zf-z)*(xf-x)/zf;
    y = yf-(zf-z)*(yf-y)/zf;
    // x = 160-x*Az/(z-Az);
    // y = 128+y*Az/(z-Az);
    zk[p] = z;
}

void ende(void)
{
    if (Win1)           CloseWindow(Win1);
    if (Win2)           CloseWindow(Win2);

    if (Scr)            CloseScreen(Scr);

    if (IntuitionBase)  CloseLibrary(IntuitionBase);
    if (GfxBase)        CloseLibrary(GfxBase);

    exit(0);
}

void main(void)
{
    short clsbytes;
    char *addr;

    IntuitionBase = OpenLibrary("intuition.library",37);
    GfxBase =	    OpenLibrary("graphics.library",37);

    if (!IntuitionBase || !GfxBase) {
	puts("Program requiers AmigaOS 2.04 or higher");
	ende();
    }

    if (!(Scr = OpenScreenTags(NULL, SA_DisplayID,HIRES, SA_Depth,1, SA_Behind,TRUE, TAG_END))) {
	puts("Can't open desired screen");
	ende();
    }

    Win1 = OpenWindowTags(NULL, WA_CustomScreen, Scr, TAG_END);
    Win2 = OpenWindowTags(NULL, WA_Left, 100, WA_Top, 100, WA_Width, 500,\
	WA_Height, 400, WA_GimmeZeroZero, TRUE,
	WA_IDCMP, IDCMP_CLOSEWINDOW,
	WA_Flags, WFLG_DEPTHGADGET|WFLG_CLOSEGADGET|WFLG_DRAGBAR|WFLG_SIZEGADGET,
	WA_Title, "3D-Rotate (created 3/93 by Klaus Rotter)",
     TAG_END);

    if (!Win1 || !Win2) {
	puts("Can't open desired windows");
	ende();
    }

    Rp = Win1->RPort;
    RpWB = Win2->RPort;

    clsbytes = (Scr->Width)*(Scr->Height)/8;
    addr = Scr->BitMap.Planes[0];

    BltClear(addr,clsbytes,1);
    ClearScreen(RpWB);

    // Vp= &(Scr->ViewPort);

    s = 0;
    sx = 0;
    do {
	xk[sx] = Data[s++];
	yk[sx] = Data[s++];
	zk[sx++] = Data[s++];
    } while (Data[s] != -1);

    s = s/6;

    l = 122;
    m = 105;
    n = 53;
    w = 0.1;
    xf = 147;
    yf = 65;
    zf = 199;
    Az = -50000;
    asc = 'y';

    FOREVER {
	q = 0;

	if (asc == 'y') asc = 'z';
	else asc = 'y';

	BltClear(addr,clsbytes,1);

	for (i=1; i<=s; i++) {
	    Richtung();
	    v = x;
	    r = y;
	    Richtung();
	    Move(Rp,trunc(x),200-trunc(y));
	    Draw(Rp,trunc(v),200-trunc(r));
	}
	BltBitMapRastPort(&(Scr->BitMap), 0,0, RpWB, 0,0,Scr->Width,Scr->Height, 0xC0);

	if (Msg = GetMsg(Win2->UserPort)) {
	    ReplyMsg(Msg);
	    ende();
	}
    }
}
