/*************************************************************************
 *
 * PROGRAM	3d-func
 * PART
 * VERSION	V0.1
 * DATE 	12/12/92
 * CHANGED
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * EMAIL	Internet: k.rotter@ame.nbg.sub.org
 *		Z-Netz:   k.rotter@ame.zer
 * COMPUTER	Amiga (OS 2.04 requiered)
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	DICE 2.06
 * COPYRIGHT	(c) Copyright 1992 by Klaus Rotter
 * COMMENT	Einfaches Programm zum zeichenen fest vorgegebener
 *		Funktionen im 3-dimensonalem Raum
 *		Spaeter soll daraus, wenn mein Funktions-Compiler
 *		fertig ist, ein vollweriges Plot Program werden
 *		Benoetigt OS 2.04
 *
 * HISTORY
 *
 *************************************************************************/

#define XOFF 320
#define YOFF 200
#define _SP_FLOAT 1
#define PI 3.14159265358

#include <math.h>
#include <libraries/mathieeesp.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/exec_protos.h>

struct IntuitionBase *IntuitionBase = NULL;
struct GfxBase *GfxBase = NULL;
struct Rastport *Rp = NULL;
struct Window *Win = NULL;

extern void quit(void);
extern void main(void);
extern void exit(int);
extern void puts(char *);

void quit(void)
{
    if (IntuitionBase) CloseLibrary(IntuitionBase);
    if (GfxBase)       CloseLibrary(GfxBase);
    if (Win)           CloseWindow(Win);
    exit(0);
}

void main(void)
{
    long  x,y,d;
    float c,e,p,q;
    float du;

    struct IntuiMsg *msg = NULL;

    IntuitionBase = OpenLibrary("intuition.library",37);
    GfxBase = OpenLibrary("graphics.library",37);

    if (!IntuitionBase || !GfxBase)
    {
	puts("Program requires AmigaOS 2.04 or higher");
	quit();
    }

    Win = OpenWindowTags(NULL,
	WA_Left, 20,
	WA_Top,  20,
	WA_Width, 600,
	WA_Height, 300,
	WA_IDCMP, IDCMP_CLOSEWINDOW|IDCMP_MENUPICK,
	WA_Flags, WFLG_DEPTHGADGET|WFLG_CLOSEGADGET|WFLG_DRAGBAR|WFLG_SIZEGADGET,
	WA_Title, "Math-demo: 3d-functions (created Dez 92 by Klaus Rotter)",
	TAG_END);

    if (!Win)
    {
	puts("Program can't open window");
	quit();
    }

    Rp = Win->RPort;

    SetAPen(Rp,1);

    for (x=0; x>-100; x--)
    {
	c = -60;
	d = 5*trunc(fsqrt(10000-x*x)/5);
	for (y=d; y>-d; y-= 5)
	{
	    e = fsqrt(x*x +  y*y);
	    e = 60*fsin(e/30)+10;
	    e = 25+e-0.6*y;
	    if (e > c)
	    {
		c = e; p=x*2; q = YOFF-e;
		WritePixel(Rp,(short) XOFF+p,(short) q);
		WritePixel(Rp,(short) XOFF-p,(short) q);
	    }
	}
    }
    msg = WaitPort(Win->UserPort);
    msg = GetMsg(Win->UserPort);
    ReplyMsg(msg);
    quit();
}


/*

a: DEF FNa(e) = 60*SIN(e/30)+10:PRINT"a":RETURN
b: DEF FNa(e) = COS(pi*e/90)*TAN(pi*e/320+1)+1:PRINT"b":RETURN
c: DEF FNa(e) = 15*ABS(LOG(e/70+.5))-LOG(e*20+.5)
d: DEF FNa(e) = ABS(e-67)-20:RETURN
e: DEF FNa(e) = 90*EXP(-e*e/1500):RETURN
f: DEF FNa(e) = 38*(SIN(e/24)+.48*SIN(3*e/24))+20:RETURN
g: DEF FNa(e) = e:PRINT"g":RETURN
h: DEF FNa(e) = 85/(e/25+1):RETURN
i: DEF FNa(e) = 30*COS(pi*e/15):RETURN
j: DEF FNa(e) = 40*COS(pi*e/55):RETURN
k: DEF FNa(e) = 10*ABS((z*z)/3000)-1:RETURN
l: DEF FNa(e) = TAN(pi*e/90+1)+1:RETURN
m: DEF FNa(e) = TAN(pi*e/320+1)+1:RETURN
n: DEF FNa(e) = 30*COS(LOG(e/30+.01)):RETURN
o: DEF FNa(e) = -50*ATN(LOG(e/30+.01)):RETURN
p: DEF FNa(e) = .5*e*e/(SQR(ABS(e*e-1))+.1):RETURN
q: DEF FNa(e) = 30*ATN(1/(e+.1))+10*pi/2:RETURN
r: DEF FNa(e) = 60*SIN(e/30)+10:RETURN

*/
