/*************************************************************************
 *
 * PROGRAM		iso2tex
 * PART
 * VERSION		1.02
 * DATE 		23/10/91
 * CHANGED		25/10/94
 * AUTHOR		Klaus Rotter
 * ADDRESS		Linsenfeld 15, 90768 Fuerth, Germany
 * COMPUTER		Amiga 500 with Kickstart 1.3 and 2.0 (37.175)
 *				25/10/94: Linux 1.1.19
 * LANGUAGE		Ansi-C
 * COMPILER		Amiga: DICE 2.06
 *				Linux: gcc 2.5.8
 * COPYRIGHT	(c) Copyright 1991 by Klaus Rotter
 *				Freely distributable under GNU Licence
 * COMMENT		Wandlet die dt. Umlaute des ISO-8851-1 Codes in die
 *				entsprechenden TeX-Befehle um
 *
 * HISTORY	23/10/91 Version 1.0
 *			18/11/91 Bug in `' -> `"O' fixed
 *      	25/10/94 Compiled on Linux, name changed to iso2tex
 *
 *************************************************************************/

#include <stdio.h>

int main(int argc, char *argv[])
{
    FILE    *fp_in, *fp_out;
    int     Zeichen = 0;
    int     i = 0, k = 0;

    printf("This is Iso2TeX Version 1.02 written 1991 by Klaus Rotter\n");

    if (argc != 3) 
    {
		printf("Usage:  Iso2TeX [-opt] <infile> [outfile]\n");
		return(0);
    }
    if (!(fp_in = fopen(argv[1],"r"))) 
    {
		printf("Error: Unabel to open input file <%s> !\n",argv[1]);
		return(0);
    }
    if (!(fp_out = fopen(argv[2],"w"))) 
    {
		printf("Error: Unabel to open output file <%s> !\n",argv[2]);
		fclose(fp_in);
		return(0);
    }
/*
    Wandelroutine
*/
    do {
	Zeichen = fgetc(fp_in);
	i++;
	switch (Zeichen) {
/*
 *   The German characters
 */
	    case 252:
		fprintf(fp_out,"\"u");    /*  */
		k++;
		break;
	    case 228:
		fprintf(fp_out,"\"a");    /*  */
		k++;
		break;
	    case 246:
		fprintf(fp_out,"\"o");    /*  */
		k++;
		break;
	    case 220:
		fprintf(fp_out,"\"U");    /*  */
		k++;
		break;
	    case 196:
		fprintf(fp_out,"\"A");    /*  */
		k++;
		break;
	    case 214:
		fprintf(fp_out,"\"O");    /*  */
		k++;
		break;
	    case 223:
		fprintf(fp_out,"\"s");   /*  */
		k++;
		break;
	    case 167:
		fprintf(fp_out,"\\SS{}");    /*  */
		k++;
		break;
/*
 *  International characters
 */
	    case 171:
		fprintf(fp_out,"$\\ll$");   /*  */
		k++;
		break;
	    case 187:
		fprintf(fp_out,"$\\gg$");   /*  */
		k++;
		break;
	    case 169:
		fprintf(fp_out,"\\copyright{}");  /*  */
		k++;
		break;
	    case 163:
		fprintf(fp_out,"\\pounds{}");   /* L */
		k++;
		break;
	    default:
		fputc((char) Zeichen,fp_out);
	}
    } while (Zeichen != EOF);

    printf("%d Bytes read,  %d chars changed.\n",i-1,k);
    fclose(fp_in);
    fclose(fp_out);
    return(0);
}
