/*************************************************************************
 *
 * PROGRAM	DelRem
 * PART
 * VERSION	1.03
 * DATE 	28/12/91
 * CHANGED	10/11/93
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * COMPUTER	Amiga 500 with Kickstart 1.3 and 2.0
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	DICE 2.07.56r
 * COPYRIGHT	(c) Copyright 1991-1993 by Klaus Rotter
 *		DelRem is freely distributable, as long as the copyright
 *		notice is unmodified.
 * COMMENT	DelRem deletes all Remarks enclosed with /* ... */ in a
 *		C-Src File
 *
 * HISTORY
 *
 *************************************************************************/

#include <stdio.h>

FILE	*fp_in,*fp_out;
char	Zeichen;

#define GetChar() fgetc(fp_in)

int ReadUntilChar(int c)
{
    int a;

    do {
	a = GetChar();
	if (a == EOF) return(1);
    } while (a != c);
    return(0);
}

void DoUn(void)
{
    printf("Unexpected end of source!\n");
    exit(-5);
}

int main(int argc, char *argv[])
{
    printf("This is CommentRemove $CM V1.02 written 1991 by Klaus Rotter\n");

    if (argc != 3) {
	printf("Usage: cr <infile> <outfile>\n");
	return(0);
    }
    if (!(fp_in = fopen(argv[1],"r"))) {
	printf("Error: Unabel to open input file <%s> !\n",argv[1]);
	return(0);
    }
    if (!(fp_out = fopen(argv[2],"w"))) {
	printf("Error: Unabel to open output file <%s> !\n",argv[2]);
	fclose(fp_in);
	return(0);
    }

    for (;;)
    {
	Zeichen = GetChar();

	if (Zeichen == '/')
	{
	    Zeichen = GetChar();
	    if (Zeichen == '*')
	    {
		do {
		    if (ReadUntilChar('*') == 1)
			DoUn();
		    do Zeichen = GetChar();
		    while (Zeichen == '*');
		} while (Zeichen != '/');
	    }
	    else {
		fputc('/',fp_out);
		fputc(Zeichen,fp_out);
	    }
	}
	else if (Zeichen == EOF)
	    break;
	else
	    fputc(Zeichen,fp_out);
    }
    fclose(fp_in);
    fclose(fp_out);
    return(0);
}
