/*************************************************************************
 *
 * PROGRAM	DirList.c
 * PART
 * VERSION	0.01
 * DATE 	28/12/91
 * CHANGED
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * COMPUTER	Amiga 500 with Kickstart 1.3 and 2.0
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	Aztec-C 5.0
 * COPYRIGHT	(c) Copyright 1991 by Klaus Rotter
 * COMMENT
 *
 * HISTORY
 *
 *************************************************************************/

#include <clib/dos_protos.h>
#include <exec/memory.h>
#include <libraries/dos.h>

#define print(s) Write(Output(),s,strlen(s))

void ReadDir (BPTR lock)
{
    struct FileInfoBlock *myfib;
    BPTR mylock, mynewlock, lock3;

    if (!(myfib=(struct FileInfoBlock *) AllocMem (sizeof(struct FileInfoBlock),MEMF_CLEAR))) Exit(-3);

    mylock = lock;
    Examine (mylock,myfib);

    while (ExNext(mylock,myfib))
    {
	print (myfib->fib_FileName);
	if ((myfib->fib_DirEntryType) > 0) {
	    print("  (dir)\n");
	    if (mynewlock = Lock ((UBYTE *) myfib->fib_FileName,ACCESS_READ))
	    {
		CurrentDir (mynewlock);
		ReadDir (mynewlock);
		if (lock3 = ParentDir (mynewlock))
		    CurrentDir (lock3);
		UnLock (mynewlock);
	    }
	}
	else
	    print ("\n");
    }
    FreeMem(myfib,sizeof(struct FileInfoBlock));
    print("-----------------------------------\n");
}

void main(int argc, char *argv[])
{
    BPTR mylock, oldlock;

    print("This is DirList V1.0 written 1991 by Klaus Rotter\n");

    if (argc != 2)
    {
	print ("Usage: DirList <dir>\n");
	return;
    }

    mylock = Lock((UBYTE *) argv[1],ACCESS_READ);
    if (mylock == 0)
    {
	print ("Can't open dir-header\n");
	return;
    }
    oldlock = CurrentDir (mylock);
    ReadDir (mylock);
    UnLock (mylock);
    if (oldlock != 0)
	CurrentDir (oldlock);
    else
	print ("Oldlock equ NULL\n");

    return;
}
