/*************************************************************************
 *
 * PROGRAM	LibMon.c
 * PART
 * VERSION	V0.2
 * DATE 	05/05/91
 * CHANGED	21/12/91
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * COMPUTER	Amiga 500 with Kickstart 1.3 and 2.0
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	DICE
 * COPYRIGHT	(c) Copyright 1991 by Klaus Rotter
 * COMMENT	This tool checks the Kickstart 1.3 library vectors
 *		if these point out of the Address space $f8000-$fffff
 * HISTORY
 *
 *************************************************************************/

struct LibLen {
    char *Library;
    int  Len;
};

struct LibLen Libs[] = {
    "clist.library",    -156,
    "console.library",   -48,
    "exec.library",     -630,
    "graphics.library", -660,
    "intuition.library",-468,
    "mathffp.library",   -96
};

short *OpenLibrary(char *,int);

void main(void)
{
    short   i,l;
    short   *LibraryBase, *LibBase;
    long    ptr;

    printf("This is LibMon V0.2, written 1991 by Klaus Rotter\n");

/*
    LibraryBase = (short *) *((long *) 0x0004L);
*/
    for (l=0; l<6; l++) {
	if (!(LibraryBase = OpenLibrary(Libs[l].Library,0L)))
	    printf("Unabel to open '%s'\n",Libs[l].Library);
	else {
	    printf("Base of %s is at: $%06lx\n",Libs[l].Library,LibraryBase);
	    LibBase = LibraryBase;
	    for (i=-30; i>= Libs[l].Len; i-=6) {
		LibBase -= 3;
		ptr = (long) (*(LibBase+1)<<16)+(*(LibBase+2));
		if (ptr > 0xffffff || ptr < 0xf80000)
		    printf("Warning: Pointer %d of %s points to $%06x\n",i,Libs[l].Library,ptr);
	    }
	    CloseLibrary(LibraryBase);
	}
    }
}
