/*************************************************************************
 *
 * PROGRAM	NewTab.c
 * PART
 * VERSION	1.01
 * DATE 	10/05/93
 * CHANGED
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * COMPUTER	Amiga 500 with Kickstart 1.3 and 2.0 (37.175)
 * EXTENSION	2MB Ram, Switching Power Supply, SCSI-52MB-HD
 * LANGUAGE	Ansi-C
 * COMPILER	DICE 2.07.54r
 * COPYRIGHT	(c) Copyright 1991 by Klaus Rotter
 * COMMENT
 *
 *
 * HISTORY	23/10/91 Version 1.0
 *		18/11/91 Bug in `' -> `\"O' fixed
 *
 *************************************************************************/

#include <stdio.h>

int main(int argc, char *argv[])
{
    FILE    *fp_in, *fp_out;

    long    newtab;

    int     Zeichen = 0;
    int     i=0, k=0, r=0;

    printf("This is NewTab version 1.0 written 1993 by Klaus Rotter\n");

    if (argc != 4)
    {
	printf("Usage: NewTab <infile> <outfile> <tabsize: 1..20>\n");
	return(0);
    }

    if (!(fp_in = fopen(argv[1],"r")))
    {
	printf("Error: Unabel to open input file <%s> !\n",argv[1]);
	return(0);
    }

    if (!(fp_out = fopen(argv[2],"w")))
    {
	printf("Error: Unabel to open output file <%s> !\n",argv[2]);
	fclose(fp_in);
	return(0);
    }

    newtab = atol(argv[3]);

    if (newtab<1 || newtab>20)
    {
	printf("Tab size is not in the allowed range !\n");
	fclose(fp_in);
	fclose(fp_out);
	return(0);
    }

/*
    Wandelroutine
*/

    do {
	Zeichen = fgetc(fp_in);
	i++;

	if (Zeichen == 9)
	{
	    r++;
	    for (k=0; k<newtab; k++)
		fputc(' ',fp_out);
	}
	else
	    fputc(Zeichen,fp_out);
    } while (Zeichen != EOF);

    printf("%d Bytes read, %d tabs changed.\n",i-1,k);
    fclose(fp_in);
    fclose(fp_out);
    return(0);
}
