/*************************************************************************
 *
 * PROGRAM	SmallCheck.c (smc)
 * PART
 * VERSION	1.01
 * DATE 	06/07/91
 * CHANGED
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * COMPUTER	Amiga 500 with Kickstart 1.3 and 2.0
 * EXTENSION	2MB Ram, Switching Power Supply, SCSI-52MB-HD
 * LANGUAGE	ANSI-C
 * COMPILER	DICE 2.06
 * COPYRIGHT	(c) Copyright 1991 by Klaus Rotter
 * COMMENT
 *
 * HISTORY
 *
 *************************************************************************/

#include <stdio.h>

FILE	*fp;
char	Zeichen;
int	size;
int	eckige_auf,eckige_zu;
int	runde_auf,runde_zu;
int	geschw_auf,geschw_zu;

int GetChar(void)
{
    size++;
    return(fgetc(fp));
}

void Ende(void)
{
    printf("\nfound: '(' %4ld  to  ')' %4ld\n",runde_auf,runde_zu);
    printf("       '{' %4ld  to  '}' %4ld\n",geschw_auf,geschw_zu);
    printf("       '[' %4ld  to  ']' %4ld\n\n",eckige_auf,eckige_zu);
    printf("%ld Bytes read.\n\n",size-1);
    fclose(fp);
    exit(0);
}

int ReadUntilChar(int c)
{
    int a;

    do {
	a = GetChar();
	if (a == EOF) return(1);
    } while (a != c);
    return(0);
}

void DoUn(void)
{
    printf("Unexpected end of source!\n");
    Ende();
}

int main(int argc, char *argv[])
{
    printf("This is SmallCheck V1.1  (c) 1991 by Klaus Rotter\n");

    if (!(argc==2)) {
	printf("Usage:  SmallCheck <input_file>\n");
	return(0);
    }
    if (!(fp = fopen(argv[1],"r"))) {
	printf("Error: Unabel to open input file <%s> !\n",argv[1]);
	return(0);
    }
/*
    Wandelroutine
*/
    do {
	Zeichen = GetChar();
	switch (Zeichen) {
	    case '{':
		geschw_auf++;
		break;
	    case '}':
		geschw_zu++;
		break;
	    case '(':
		runde_auf++;
		break;
	    case ')':
		runde_zu++;
		break;
	    case '[':
		eckige_auf++;
		break;
	    case ']':
		eckige_zu++;
		break;
	    case '"':
		if (ReadUntilChar('"') == 1)
		    DoUn();
		break;
	    case  39:		/* ' */
		if (ReadUntilChar(39) == 1)
		    DoUn();
		break;
	    case '/':
		if (GetChar() == '*') {
		    do {
			if (ReadUntilChar('*') == 1)
			    DoUn();
		    } while (GetChar() != '/');
		}
		else
		    fseek(fp,-1,1);
		break;
	}
    } while (Zeichen != EOF);
    Ende();
}
