/*************************************************************************
 *
 * PROGRAM	3d-func
 * PART
 * VERSION	V0.1
 * DATE 	12/12/92
 * CHANGED	11/22/94
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 90768 Fuerth, Germany
 * EMAIL	rotter@mi.uni-erlangen.de
 * COMPUTER	Linux
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	GCC 2.5.8
 * COPYRIGHT	(c) Copyright 1992 by Klaus Rotter
 * COMMENT	Einfaches Programm zum zeichenen fest vorgegebener
 *		Funktionen im 3-dimensonalem Raum
 *
 * HISTORY	12/12/92 Amiga Version
 *		11/22/94 Ported to Linux under XView
 *
 *************************************************************************/

#define XOFF 320
#define YOFF 200
#define _SP_FLOAT 1
#define PI 3.14159265358

#include <math.h>
#include <X11/Xlib.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/panel.h>
#include <xview/frame.h>


extern void quit (void);
extern void paint ();

/*
extern void main(void);
extern void exit(int);
extern void puts(char *);
*/

Frame frame;
Panel panel;
Canvas canvas;

int step = 24;

void quit(void)
{
    xv_destroy_safe (frame);
    exit(0);
}

void main (int argc, char *argv[])
{

    xv_init (XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

    frame = (Frame) xv_create (XV_NULL, FRAME, NULL);

    panel = (Panel) xv_create (frame, PANEL, PANEL_LAYOUT, PANEL_VERTICAL, NULL);

    xv_create (panel, PANEL_BUTTON,
	PANEL_LABEL_STRING,	"Quit",
	PANEL_NOTIFY_PROC,	quit,
	NULL);

    xv_create (panel, PANEL_BUTTON,
	PANEL_LABEL_STRING,	"Next",
	PANEL_NOTIFY_PROC,	paint,
	NULL);

    window_fit_width (panel);

    canvas = (Canvas) xv_create (frame, CANVAS,
	CANVAS_REPAINT_PROC,	paint,
	CANVAS_X_PAINT_WINDOW,	TRUE,
	NULL);

    xv_main_loop (frame);
}

void paint (void)
{
    long  x,y,d;
    float c,e,p,q;
    float du;

    GC 		gc;
    Window 	xwin;
    Display	*dpy;
 
    step++;
    if (step > 30) step = 1;
    
    xwin = (Window) xv_get (canvas_paint_window (canvas), XV_XID);
    dpy = (Display *) xv_get (frame, XV_DISPLAY);
    
    gc = DefaultGC (dpy, DefaultScreen (dpy) );

    XClearWindow (dpy, xwin);	

    for (x=0; x>-100; x--)
    {
	    c = -60;
	    d = 5 * (int) (sqrt(10000-x*x)/5);
	    for (y=d; y>-d; y-= 5)
	    {
            e = sqrt(x*x +  y*y);

	        e = 38 * (sin (e / (float) step) + .48 * sin (3 * e / (float) step)) + 20; break;
	        e = 25+e-0.6*y;
	        if (e > c)
	        {
		        c = e; p=x*2; q = YOFF-e;
		        XDrawPoint (dpy, xwin, gc, (int) XOFF+p, (int) q);
		        XDrawPoint (dpy, xwin, gc, (int) XOFF-p, (int) q);
	        }
	    }
    }    
}