/*************************************************************************
 *
 * PROGRAM	3d-func
 * PART
 * VERSION	V0.1
 * DATE 	12/12/92
 * CHANGED	11/22/94
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 90768 Fuerth, Germany
 * EMAIL	rotter@mi.uni-erlangen.de
 * COMPUTER	Linux
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	GCC 2.5.8
 * COPYRIGHT	(c) Copyright 1992 by Klaus Rotter
 * COMMENT	Einfaches Programm zum zeichenen fest vorgegebener
 *		Funktionen im 3-dimensonalem Raum
 *
 * HISTORY	12/12/92 Amiga Version
 *		11/22/94 Ported to Linux under XView
 *
 *************************************************************************/

#define XOFF 320
#define YOFF 200
#define _SP_FLOAT 1
#define PI 3.14159265358

#include <math.h>
#include <X11/Xlib.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/panel.h>
#include <xview/frame.h>


extern void quit (void);
extern void paint ();

/*
extern void main(void);
extern void exit(int);
extern void puts(char *);
*/

Frame frame;
Panel panel;
Canvas canvas;

int funcount = 0;

void quit(void)
{
    xv_destroy_safe (frame);
    exit(0);
}

void next (void)
{
    funcount++;

    if (funcount > 17) funcount = 0;
    paint();	
}    	

void main (int argc, char *argv[])
{

    xv_init (XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

    frame = (Frame) xv_create (XV_NULL, FRAME, NULL);

    panel = (Panel) xv_create (frame, PANEL, PANEL_LAYOUT, PANEL_VERTICAL, NULL);

    xv_create (panel, PANEL_BUTTON,
	PANEL_LABEL_STRING,	"Quit",
	PANEL_NOTIFY_PROC,	quit,
	NULL);

    xv_create (panel, PANEL_BUTTON,
	PANEL_LABEL_STRING,	"Next",
	PANEL_NOTIFY_PROC,	next,
	NULL);

    window_fit_width (panel);

    canvas = (Canvas) xv_create (frame, CANVAS,
	CANVAS_REPAINT_PROC,	paint,
	CANVAS_X_PAINT_WINDOW,	TRUE,
	NULL);

    xv_main_loop (frame);
}

void paint (void)
{
    long  x,y,d;
    float c,e,p,q;
    float du;

    GC 		gc;
    Window 	xwin;
    Display	*dpy;
    
    xwin = (Window) xv_get (canvas_paint_window (canvas), XV_XID);
    dpy = (Display *) xv_get (frame, XV_DISPLAY);
    
    gc = DefaultGC (dpy, DefaultScreen (dpy) );

    XClearWindow (dpy, xwin);	

    for (x=0; x>-100; x--)
    {
	c = -60;
	d = 5 * (int) (sqrt(10000-x*x)/5);
	for (y=d; y>-d; y-= 5)
	{
	    e = sqrt(x*x +  y*y);

	    switch (funcount)
	    {
	    	case  0: e = 60 * sin (e / 30) + 10; break;
	    	case  1: e = cos (PI * e / 90) * tan (PI * e / 320 + 1) + 1; break;
	    	case  2: e = 15 * abs (log (e / 70 + .5)) - log (e * 20 + .5); break;
	    	case  3: e = abs (e - 67) - 20; break;
	    	case  5: e = 90 * exp( -e * e / 1500); break;
	    	case  6: e = 38 * (sin (e / 24) + .48 * sin (3 * e / 24)) + 20; break;
	    	case  7: e = e; break;
            	case  8: e = 85 / (e / 25 + 1); break;
	    	case  9: e = 30 * cos(PI * e / 15); break;
            	case 10: e = 40*cos(PI*e/55); break;
            	case 11: e = 10*abs((e*e)/3000)-1; break;
            	case 12: e = tan(PI*e/90+1)+1; break;
            	case 13: e = tan(PI*e/320+1)+1; break;
            	case 14: e = 30*cos(log(e/30+.01)); break;
            	case 15: e = -50*atan(log(e/30+.01)); break;
            	case 16: e = .5*e*e/(sqrt(abs(e*e-1))+.1); break;
            	case 17: e = 30*atan(1/(e+.1))+10*PI/2; break;
	    }            

	    e = 25+e-0.6*y;
	    if (e > c)
	    {
		c = e; p=x*2; q = YOFF-e;
		XDrawPoint (dpy, xwin, gc, (int) XOFF+p, (int) q);
		XDrawPoint (dpy, xwin, gc, (int) XOFF-p, (int) q);
	    }
	}
    }    
}