/*************************************************************************
 *
 * PROGRAM	MiniMand
 * PART
 * VERSION	V0.1
 * DATE 	10.12.92
 * CHANGED
 * AUTHOR	Klaus Rotter
 * ADDRESS	Linsenfeld 15, 8510 Fuerth, Germany
 * EMAIL	Internet: k.rotter@ame.nbg.sub.org
 *		Z-Netz:   k.rotter@ame.zer
 * COMPUTER	Amiga (OS 2.04 needed)
 * EXTENSION
 * LANGUAGE	ANSI-C
 * COMPILER	DICE 2.06
 * COPYRIGHT	(c) Copyright 1992 by Klaus Rotter
 * COMMENT
 *
 * HISTORY
 *
 *************************************************************************/

#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/exec_protos.h>

static short color[] = {
    0x000, 0x03F, 0x05F, 0x08F, 0x0AF, 0x0DF, 0x0FE, 0x0F8, 0x0F6,
    0x0F3, 0x0F0, 0x3F0, 0x5F0, 0x8F0, 0x0F0, 0x2F0, 0x5F0, 0x5C0,
    0x5A0, 0x590, 0xF50, 0xF20, 0xF00, 0xF04, 0xF08, 0xF09, 0xF0C,
    0xF0F, 0xB0F, 0x70F, 0x40F, 0x00F
};

#define MAX_X 320
#define MAX_Y 256
#define MAX_FARBEN 31
#define MAX_IT 50
#define MIN_R (-2*32768)
#define MAX_R (2*32768)
#define MIN_I (-2*32768)
#define MAX_I (2*32768)
#define DELTA_X (((MAX_R)-(MIN_R))/MAX_X)
#define DELTA_Y (((MAX_I)-(MIN_I))/MAX_Y)

struct	IntuitionBase *IntuitionBase;
struct	GfxBase       *GfxBase;

void _main(void)
{
    short   zeile, spalte, farbe;
    int     cr = MIN_R, ci = MAX_I, zr, zi, i;
    short   it;
    char    *cia = (char *) 0xBFE001;
    char    reg;

    struct Screen   *Scr;
    struct RastPort *Rp;
    struct ViewPort *Vp;

    IntuitionBase = OpenLibrary("intuition.library",37);
    GfxBase	  = OpenLibrary("graphics.library",37);

    if (!IntuitionBase) exit(-10);

    // Kurze Art und Weise, unter OS2.04 einen Screen zu oeffnen

    Scr = OpenScreenTags(NULL, SA_Depth, 5, TAG_END);

    if (!Scr) exit(-20);

    Rp= &(Scr->RastPort);
    Vp= &(Scr->ViewPort);

    LoadRGB4(Vp,&color[0],32);

    // Dies ist nun der eigentliche Algorithmus, der die Mandelbrot
    // Menge bestimmt.

    for (zeile=0; zeile<=MAX_Y; zeile++)
    {
	for (spalte=0; spalte<=MAX_X; spalte++)
	{
	    it = 0;
	    zr = 0;
	    zi = 0;

	    while ((it < MAX_IT) && (zr<2*32768) && (zi<2*32768))
	    {
		i = zi;
		zi = 2*i*zr/32768-ci;		    // (2*32768)*i/32768*zr/32768-cr
		zr = zr*zr/32768-i*i/32768-cr;
		it++;
	    }
	    farbe = (it % MAX_FARBEN)+1;
	    if (it >= MAX_IT) farbe = 0;
	    SetAPen(Rp,farbe);
	    WritePixel(Rp,spalte,zeile);
	    cr += DELTA_X;

	    // Prueft, ob linke Maustaste gedrueckt ist, wenn ja,
	    // so wird das Programm beendet

	    reg = *cia;
	    if (!(reg & 64))   // Soll's kurz sein, so braucht man ein goto
		goto ende;  // sorry...
	}
	cr = MIN_R;
	ci -= DELTA_Y;
    }
ende:
    CloseScreen(Scr);
    CloseLibrary(IntuitionBase);
    CloseLibrary(GfxBase);
}
